unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TNotSafeObject = class
  private
    FIntField: Integer;
  public
    constructor Create(const aInteger: integer);
    property IntField: Integer read FIntField write FIntField;
  end;

  TSafeObject = class
  private
    FIntField: Integer;
    function GetIntField: Integer;
  public
    constructor Create(const aInteger: integer);
    property IntField: Integer read GetIntField write FIntField;
  end;

type
  TForm7 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    NotSafeObject: TNotSafeObject;
    SafeObject: TSafeObject;
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

{$R *.dfm}

{ TEasyManageableRecord }

constructor TSafeObject.Create(const aInteger: integer);
begin
  FIntField := aInteger;
end;

function TSafeObject.GetIntField: Integer;
begin
  result := -1;
  if not Assigned(Self) then
    exit;
  Result := FIntField;
end;

{ TNotEasyManageableRecord }

constructor TNotSafeObject.Create(const aInteger: integer);
begin
  FIntField := aInteger;
end;

procedure TForm7.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  i := NotSafeObject.IntField;
end;

procedure TForm7.Button2Click(Sender: TObject);
var
  i: Integer;
begin
  i := SafeObject.IntField;
end;

end.
